"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toCodeDeployClientConfig = exports.setCodeDeployServiceConfig = exports.withCodeDeployServiceConfig = void 0;
const commons_1 = require("@effect-aws/commons");
const effect_1 = require("effect");
const Function_1 = require("effect/Function");
const GlobalValue_1 = require("effect/GlobalValue");
/**
 * @since 1.0.0
 * @category codedeploy service config
 */
const currentCodeDeployServiceConfig = (0, GlobalValue_1.globalValue)("@effect-aws/client-codedeploy/currentCodeDeployServiceConfig", () => effect_1.FiberRef.unsafeMake({}));
/**
 * @since 1.0.0
 * @category codedeploy service config
 */
exports.withCodeDeployServiceConfig = (0, Function_1.dual)(2, (effect, config) => effect_1.Effect.locally(effect, currentCodeDeployServiceConfig, config));
/**
 * @since 1.0.0
 * @category codedeploy service config
 */
const setCodeDeployServiceConfig = (config) => effect_1.Layer.locallyScoped(currentCodeDeployServiceConfig, config);
exports.setCodeDeployServiceConfig = setCodeDeployServiceConfig;
/**
 * @since 1.0.0
 * @category adapters
 */
exports.toCodeDeployClientConfig = effect_1.Effect.gen(function* () {
    const { logger: serviceLogger, ...config } = yield* effect_1.FiberRef.get(currentCodeDeployServiceConfig);
    const logger = serviceLogger === true
        ? yield* commons_1.ServiceLogger.toClientLogger(commons_1.ServiceLogger.defaultServiceLogger)
        : (serviceLogger ? yield* commons_1.ServiceLogger.toClientLogger(commons_1.ServiceLogger.make(serviceLogger)) : undefined);
    return { logger, ...config };
});
//# sourceMappingURL=CodeDeployServiceConfig.js.map