/**
 * @since 1.0.0
 */
import { AddTagsToOnPremisesInstancesCommand, BatchGetApplicationRevisionsCommand, BatchGetApplicationsCommand, BatchGetDeploymentGroupsCommand, BatchGetDeploymentInstancesCommand, BatchGetDeploymentsCommand, BatchGetDeploymentTargetsCommand, BatchGetOnPremisesInstancesCommand, ContinueDeploymentCommand, CreateApplicationCommand, CreateDeploymentCommand, CreateDeploymentConfigCommand, CreateDeploymentGroupCommand, DeleteApplicationCommand, DeleteDeploymentConfigCommand, DeleteDeploymentGroupCommand, DeleteGitHubAccountTokenCommand, DeleteResourcesByExternalIdCommand, DeregisterOnPremisesInstanceCommand, GetApplicationCommand, GetApplicationRevisionCommand, GetDeploymentCommand, GetDeploymentConfigCommand, GetDeploymentGroupCommand, GetDeploymentInstanceCommand, GetDeploymentTargetCommand, GetOnPremisesInstanceCommand, ListApplicationRevisionsCommand, ListApplicationsCommand, ListDeploymentConfigsCommand, ListDeploymentGroupsCommand, ListDeploymentInstancesCommand, ListDeploymentsCommand, ListDeploymentTargetsCommand, ListGitHubAccountTokenNamesCommand, ListOnPremisesInstancesCommand, ListTagsForResourceCommand, PutLifecycleEventHookExecutionStatusCommand, RegisterApplicationRevisionCommand, RegisterOnPremisesInstanceCommand, RemoveTagsFromOnPremisesInstancesCommand, SkipWaitTimeForInstanceTerminationCommand, StopDeploymentCommand, TagResourceCommand, UntagResourceCommand, UpdateApplicationCommand, UpdateDeploymentGroupCommand, } from "@aws-sdk/client-codedeploy";
import { Service } from "@effect-aws/commons";
import { Effect, Layer } from "effect";
import * as Instance from "./CodeDeployClientInstance.js";
import * as CodeDeployServiceConfig from "./CodeDeployServiceConfig.js";
import { AllServiceErrors } from "./Errors.js";
const commands = {
    AddTagsToOnPremisesInstancesCommand,
    BatchGetApplicationRevisionsCommand,
    BatchGetApplicationsCommand,
    BatchGetDeploymentGroupsCommand,
    BatchGetDeploymentInstancesCommand,
    BatchGetDeploymentTargetsCommand,
    BatchGetDeploymentsCommand,
    BatchGetOnPremisesInstancesCommand,
    ContinueDeploymentCommand,
    CreateApplicationCommand,
    CreateDeploymentCommand,
    CreateDeploymentConfigCommand,
    CreateDeploymentGroupCommand,
    DeleteApplicationCommand,
    DeleteDeploymentConfigCommand,
    DeleteDeploymentGroupCommand,
    DeleteGitHubAccountTokenCommand,
    DeleteResourcesByExternalIdCommand,
    DeregisterOnPremisesInstanceCommand,
    GetApplicationCommand,
    GetApplicationRevisionCommand,
    GetDeploymentCommand,
    GetDeploymentConfigCommand,
    GetDeploymentGroupCommand,
    GetDeploymentInstanceCommand,
    GetDeploymentTargetCommand,
    GetOnPremisesInstanceCommand,
    ListApplicationRevisionsCommand,
    ListApplicationsCommand,
    ListDeploymentConfigsCommand,
    ListDeploymentGroupsCommand,
    ListDeploymentInstancesCommand,
    ListDeploymentTargetsCommand,
    ListDeploymentsCommand,
    ListGitHubAccountTokenNamesCommand,
    ListOnPremisesInstancesCommand,
    ListTagsForResourceCommand,
    PutLifecycleEventHookExecutionStatusCommand,
    RegisterApplicationRevisionCommand,
    RegisterOnPremisesInstanceCommand,
    RemoveTagsFromOnPremisesInstancesCommand,
    SkipWaitTimeForInstanceTerminationCommand,
    StopDeploymentCommand,
    TagResourceCommand,
    UntagResourceCommand,
    UpdateApplicationCommand,
    UpdateDeploymentGroupCommand,
};
/**
 * @since 1.0.0
 * @category constructors
 */
export const makeCodeDeployService = Effect.gen(function* () {
    const client = yield* Instance.CodeDeployClientInstance;
    return Service.fromClientAndCommands(client, commands, AllServiceErrors);
});
/**
 * @since 1.0.0
 * @category models
 */
export class CodeDeployService extends Effect.Tag("@effect-aws/client-codedeploy/CodeDeployService")() {
    static defaultLayer = Layer.effect(this, makeCodeDeployService).pipe(Layer.provide(Instance.layer));
    static layer = (config) => Layer.effect(this, makeCodeDeployService).pipe(Layer.provide(Instance.layer), Layer.provide(CodeDeployServiceConfig.setCodeDeployServiceConfig(config)));
    static baseLayer = (evaluate) => Layer.effect(this, makeCodeDeployService).pipe(Layer.provide(Layer.effect(Instance.CodeDeployClientInstance, Effect.map(CodeDeployServiceConfig.toCodeDeployClientConfig, evaluate))));
}
//# sourceMappingURL=CodeDeployService.js.map